/*
 * Copyright (c) 1999-2000 Image Power, Inc. and the University of
 *   British Columbia.
 * Copyright (c) 2001 Michael David Adams.
 * All rights reserved.
 *
 * The complete licensing terms for this software can be found in the file
 * named "LICENSE" in this software distribution.
 */

/*
 * Multicomponent Transform Library
 *
 * $Id$
 */

#ifndef MCT_H
#define MCT_H

/******************************************************************************\
* Includes.
\******************************************************************************/

#include "seq.h"
#include "fix.h"

/******************************************************************************\
* Functions.
\******************************************************************************/

#define MCT_NONE	0
#define MCT_ICT		1
#define MCT_RCT		2

void rct(matrix_t *c0, matrix_t *c1, matrix_t *c2);
void irct(matrix_t *c0, matrix_t *c1, matrix_t *c2);

void ict(matrix_t *c0, matrix_t *c1, matrix_t *c2);
void iict(matrix_t *c0, matrix_t *c1, matrix_t *c2);

fix_t mct_getsynweight(int mctid, int cmptno);

#endif
