/*
 * Copyright (c) 1999-2000 Image Power, Inc. and the University of
 *   British Columbia.
 * Copyright (c) 2001 Michael David Adams.
 * All rights reserved.
 *
 * The complete licensing terms for this software can be found in the file
 * named "LICENSE" in this software distribution.
 */

/*
 * MQ Arithmetic Coder
 *
 * $Id$
 */

/******************************************************************************\
* Includes.
\******************************************************************************/

#include "memalloc.h"
#include "mqcod.h"

/******************************************************************************\
* Data.
\******************************************************************************/

/* MQ coder per-state information. */

mqstate_t mqstates[47 * 2] = {
	{0x5601, 0, &mqstates[ 2], &mqstates[ 3]},
	{0x5601, 1, &mqstates[ 3], &mqstates[ 2]},
	{0x3401, 0, &mqstates[ 4], &mqstates[12]},
	{0x3401, 1, &mqstates[ 5], &mqstates[13]},
	{0x1801, 0, &mqstates[ 6], &mqstates[18]},
	{0x1801, 1, &mqstates[ 7], &mqstates[19]},
	{0x0ac1, 0, &mqstates[ 8], &mqstates[24]},
	{0x0ac1, 1, &mqstates[ 9], &mqstates[25]},
	{0x0521, 0, &mqstates[10], &mqstates[58]},
	{0x0521, 1, &mqstates[11], &mqstates[59]},
	{0x0221, 0, &mqstates[76], &mqstates[66]},
	{0x0221, 1, &mqstates[77], &mqstates[67]},
	{0x5601, 0, &mqstates[14], &mqstates[13]},
	{0x5601, 1, &mqstates[15], &mqstates[12]},
	{0x5401, 0, &mqstates[16], &mqstates[28]},
	{0x5401, 1, &mqstates[17], &mqstates[29]},
	{0x4801, 0, &mqstates[18], &mqstates[28]},
	{0x4801, 1, &mqstates[19], &mqstates[29]},
	{0x3801, 0, &mqstates[20], &mqstates[28]},
	{0x3801, 1, &mqstates[21], &mqstates[29]},
	{0x3001, 0, &mqstates[22], &mqstates[34]},
	{0x3001, 1, &mqstates[23], &mqstates[35]},
	{0x2401, 0, &mqstates[24], &mqstates[36]},
	{0x2401, 1, &mqstates[25], &mqstates[37]},
	{0x1c01, 0, &mqstates[26], &mqstates[40]},
	{0x1c01, 1, &mqstates[27], &mqstates[41]},
	{0x1601, 0, &mqstates[58], &mqstates[42]},
	{0x1601, 1, &mqstates[59], &mqstates[43]},
	{0x5601, 0, &mqstates[30], &mqstates[29]},
	{0x5601, 1, &mqstates[31], &mqstates[28]},
	{0x5401, 0, &mqstates[32], &mqstates[28]},
	{0x5401, 1, &mqstates[33], &mqstates[29]},
	{0x5101, 0, &mqstates[34], &mqstates[30]},
	{0x5101, 1, &mqstates[35], &mqstates[31]},
	{0x4801, 0, &mqstates[36], &mqstates[32]},
	{0x4801, 1, &mqstates[37], &mqstates[33]},
	{0x3801, 0, &mqstates[38], &mqstates[34]},
	{0x3801, 1, &mqstates[39], &mqstates[35]},
	{0x3401, 0, &mqstates[40], &mqstates[36]},
	{0x3401, 1, &mqstates[41], &mqstates[37]},
	{0x3001, 0, &mqstates[42], &mqstates[38]},
	{0x3001, 1, &mqstates[43], &mqstates[39]},
	{0x2801, 0, &mqstates[44], &mqstates[38]},
	{0x2801, 1, &mqstates[45], &mqstates[39]},
	{0x2401, 0, &mqstates[46], &mqstates[40]},
	{0x2401, 1, &mqstates[47], &mqstates[41]},
	{0x2201, 0, &mqstates[48], &mqstates[42]},
	{0x2201, 1, &mqstates[49], &mqstates[43]},
	{0x1c01, 0, &mqstates[50], &mqstates[44]},
	{0x1c01, 1, &mqstates[51], &mqstates[45]},
	{0x1801, 0, &mqstates[52], &mqstates[46]},
	{0x1801, 1, &mqstates[53], &mqstates[47]},
	{0x1601, 0, &mqstates[54], &mqstates[48]},
	{0x1601, 1, &mqstates[55], &mqstates[49]},
	{0x1401, 0, &mqstates[56], &mqstates[50]},
	{0x1401, 1, &mqstates[57], &mqstates[51]},
	{0x1201, 0, &mqstates[58], &mqstates[52]},
	{0x1201, 1, &mqstates[59], &mqstates[53]},
	{0x1101, 0, &mqstates[60], &mqstates[54]},
	{0x1101, 1, &mqstates[61], &mqstates[55]},
	{0x0ac1, 0, &mqstates[62], &mqstates[56]},
	{0x0ac1, 1, &mqstates[63], &mqstates[57]},
	{0x09c1, 0, &mqstates[64], &mqstates[58]},
	{0x09c1, 1, &mqstates[65], &mqstates[59]},
	{0x08a1, 0, &mqstates[66], &mqstates[60]},
	{0x08a1, 1, &mqstates[67], &mqstates[61]},
	{0x0521, 0, &mqstates[68], &mqstates[62]},
	{0x0521, 1, &mqstates[69], &mqstates[63]},
	{0x0441, 0, &mqstates[70], &mqstates[64]},
	{0x0441, 1, &mqstates[71], &mqstates[65]},
	{0x02a1, 0, &mqstates[72], &mqstates[66]},
	{0x02a1, 1, &mqstates[73], &mqstates[67]},
	{0x0221, 0, &mqstates[74], &mqstates[68]},
	{0x0221, 1, &mqstates[75], &mqstates[69]},
	{0x0141, 0, &mqstates[76], &mqstates[70]},
	{0x0141, 1, &mqstates[77], &mqstates[71]},
	{0x0111, 0, &mqstates[78], &mqstates[72]},
	{0x0111, 1, &mqstates[79], &mqstates[73]},
	{0x0085, 0, &mqstates[80], &mqstates[74]},
	{0x0085, 1, &mqstates[81], &mqstates[75]},
	{0x0049, 0, &mqstates[82], &mqstates[76]},
	{0x0049, 1, &mqstates[83], &mqstates[77]},
	{0x0025, 0, &mqstates[84], &mqstates[78]},
	{0x0025, 1, &mqstates[85], &mqstates[79]},
	{0x0015, 0, &mqstates[86], &mqstates[80]},
	{0x0015, 1, &mqstates[87], &mqstates[81]},
	{0x0009, 0, &mqstates[88], &mqstates[82]},
	{0x0009, 1, &mqstates[89], &mqstates[83]},
	{0x0005, 0, &mqstates[90], &mqstates[84]},
	{0x0005, 1, &mqstates[91], &mqstates[85]},
	{0x0001, 0, &mqstates[90], &mqstates[86]},
	{0x0001, 1, &mqstates[91], &mqstates[87]},
	{0x5601, 0, &mqstates[92], &mqstates[92]},
	{0x5601, 1, &mqstates[93], &mqstates[93]},
};
