/*
 * Copyright (c) 2001 Michael David Adams.
 * All rights reserved.
 *
 * The complete licensing terms for this software can be found in the file
 * named "LICENSE" in this software distribution.
 */

#ifndef MIF_H
#define MIF_H

/******************************************************************************\
* Includes.
\******************************************************************************/

#include "types.h"

/******************************************************************************\
* Constants.
\******************************************************************************/

#define	MIF_MAGIC		0x4d49460a
/* signature */

#define	MIF_MAGICLEN	4
/* length of signature in bytes */

/******************************************************************************\
* Types.
\******************************************************************************/

/* Per-component information. */

typedef struct {

	int_fast32_t tlx;

	int_fast32_t tly;

	int_fast32_t width;

	int_fast32_t height;

	int_fast32_t sampperx;

	int_fast32_t samppery;

	int_fast16_t prec;

	int_fast16_t sgnd;

	char *data;

} mif_cmpt_t;

/* MIF header. */

typedef struct {

	uint_fast32_t magic;

	int numcmpts;

	int maxcmpts;

	mif_cmpt_t **cmpts;

} mif_hdr_t;

#endif
